//////////////////////////////////////////////////////////
////Created by Spunky_Girl on 4/5/09 (April 5th, 2009)////
//////////////////////////////////////////////////////////

/*

  This is just a little demonstration on how to make a minor Beam-like verb
by just modifying built-in procedures, Move() and New()

*/

turf
	Grass
		icon = 'Mapping.dmi'
		icon_state = "grass"

world
	turf = /turf/Grass
	loop_checks = 0

mob
	icon = 'Player.dmi'
	var/canSpam = TRUE
	verb/Beam()
		if(!canSpam) return
		new/obj/Beam/head(get_step(src,dir),src,dir)
		canSpam = FALSE
		spawn(30) canSpam = TRUE

obj
	var/Owner
	Beam
		icon = 'Beams.dmi'
		density = 1
		New(loc,o,d)
			..()
			Owner = o
			dir = d
			spawn(20)
				for(var/obj/Beam/B)
					if(B.Owner == Owner)
						del B
		head
			icon_state = "head"
			New()
				..()
				walk(src,src.dir)
			Move()                                           //Every time the head of the beam moves...
				..()
				var/turf/T1 = get_step(src,src.dir)               //check if there's a turf in front of the head of the beam.
				if(!T1)                                              //If the turf does not exists...
					for(var/obj/Beam/B)                                //find all beams...
						if(B.Owner == Owner)                             //that belong to the owner...
							del B                                          //and delete them.
				var/turf/T2 = get_step(src,turn(src.dir,180))     //check the turf behind the head of the beam...
				if(T2) new/obj/Beam/tail(T2,Owner,dir)               //and if it exists, create a tail obj of the beam there.
		tail
			icon_state = "tail"